       subroutine cbpa1d(x,z,xi,zi,zxi,zxxi)
	  
c***********************************************************************
c      Complex Barycentric PArabolic interpolation 1D
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Faro, 25/10/2010 at 14:30
c****&******************************************************************
       
       integer*4 i
       
       real*8 x(3)
       real*8 px(2),sx(2)
       real*8 xi,x1,x2,x3
       
       complex*16 z(3)
       complex*16 a(2)
       complex*16 zi,zxi,zxxi
       
c***********************************************************************
       
       x1 = x(1)
       x2 = x(2)
       x3 = x(3)

       px(1) = ( x2 - x1 )*( x2 - x3 )
       px(2) = ( x3 - x1 )*( x3 - x2 )
       
       a(1) = ( z(2) - z(1) )/px(1)
       a(2) = ( z(3) - z(1) )/px(2)

       px(1) = ( xi - x1 )*( xi - x3 )
       px(2) = ( xi - x1 )*( xi - x2 )
       
       sx(1) = 2.0*xi - x1 - x3
       sx(2) = 2.0*xi - x1 - x2
       
       zi   = z(1) + a(1)*px(1) +     a(2)*px(2)
       zxi  =        a(1)*sx(1) +     a(2)*sx(2)
       zxxi =    2.0*a(1)       + 2.0*a(2)
       
c***********************************************************************
c     Back to main:
c***********************************************************************        
       
       return 
       
       end
