       subroutine cvals1(nx,tabx,tabc,xi,ci,cxi,cxxi)
       
c***********************************************************************
c      CVALS1.FOR
c      (1D) Interpolation of sound speed and its derivatives.
c      Faro, Seg Fev  6 23:32:29 WET 2017
c      Written by Orlando Camargo Rodriguez
c****&******************************************************************

c      Define local variables:

       integer*4 i, nx

       real*8 tabx(nx),tabc(nx)
       real*8 xc(4),fc(4)
       real*8 xl(2),fl(2)
       real*8 xi,ci,cxi,cxxi
       
c-----------------------------------------------------------------------
       
       cxxi = 0.0
       
       if (xi.lt.tabx(2)) then
       
       xl(1) = tabx(1)
       xl(2) = tabx(2)
       
       fl(1) = tabc(1)
       fl(2) = tabc(2)
       
       call lini1d(xl,fl,xi,ci,cxi)
       
       elseif (xi.ge.tabx(nx-1)) then
       
       xl(1) = tabx(nx-1)
       xl(2) = tabx( nx )
       
       fl(1) = tabc(nx-1)
       fl(2) = tabc( nx )
       
       call lini1d(xl,fl,xi,ci,cxi)

       else 
       
       call brcket(nx,tabx,xi,i)

       xc(1) = tabx(i-1)
       xc(2) = tabx( i )
       xc(3) = tabx(i+1)
       xc(4) = tabx(i+2)
       
       fc(1) = tabc(i-1)
       fc(2) = tabc( i )
       fc(3) = tabc(i+1)
       fc(4) = tabc(i+2)
       
       call bcui1d(xc,fc,xi,ci,cxi,cxxi)

       end if

c-----------------------------------------------------------------------

c***********************************************************************
c     Back to main:
c***********************************************************************

       return

       end
