       subroutine star(imax,rc,zc,q0,irefl,dr,dz,pl,pc,pr,pu,pd)

c***********************************************************************
c      STAR pressure contributions for velocity components
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Faro, 22/11/2010 at 19:30
c****&******************************************************************

c      Include global (common) variables:

       include 'global.for'

c      Define local variables:

       integer*4 irefl(np)

       integer*4 i,imax

       real*8 xl(2),yl(2)

       real*8 rl,rc,rr,zu,zc,zd,dr,dz
       real*8 tauray,zray,qray,dzdr,thta,q0,w

       real*8 dummy

       complex*16 aray,pl,pc,pr,pu,pd

       complex*16 dummi

c***********************************************************************

       pl = (0.0 , 0.0)
       pc = (0.0 , 0.0)
       pr = (0.0 , 0.0)
       pu = (0.0 , 0.0)
       pd = (0.0 , 0.0)

       rl = rc - dr
       rr = rc + dr
       zd = zc - dz
       zu = zc + dz
       
       call brcket(imax,r,rl,i)

       if ((i.ne.0).and.(i.ne.imax)) then

       call grayp(imax,irefl,i,q0,rl,dzdr,tauray,zray,
     & aray,qray,w)
       call gpress(i,rl,zc,tauray,zray,dzdr,aray,w,pl)

       end if

       call brcket(imax,r,rc,i)

       if ((i.ne.0).and.(i.ne.imax)) then

       call grayp(imax,irefl,i,q0,rc,dzdr,tauray,zray,
     & aray,qray,w)
       call gpress(i,rc,zc,tauray,zray,dzdr,aray,w,pc)
       call gpress(i,rc,zd,tauray,zray,dzdr,aray,w,pd)
       call gpress(i,rc,zu,tauray,zray,dzdr,aray,w,pu)

       end if

       call brcket(imax,r,rr,i)

       if ((i.ne.0).and.(i.ne.imax)) then

       call grayp(imax,irefl,i,q0,rr,dzdr,tauray,zray,
     & aray,qray,w)
       call gpress(i,rr,zc,tauray,zray,dzdr,aray,w,pr)

       end if

c***********************************************************************
c      Back to main:
c*********************************************************************** 

       return

       end
